cat asterisk-1.4.22-sipbug-etk.diff
--- asterisk-1.4.22/channels/chan_sip.c 2008-09-08 23:10:10.000000000 +0200
+++ asterisk-1.4.22-etk/channels/chan_sip.c     2008-11-27 14:03:08.000000000 +0100
@@ -5133,8 +5133,10 @@
                int audio = FALSE;

                numberofports = 1;
-               if ((sscanf(m, "audio %d/%d RTP/AVP %n", &x, &numberofports, &len) == 2) ||
-                   (sscanf(m, "audio %d RTP/AVP %n", &x, &len) == 1)) {
+               len=-1;
+               if (((sscanf(m, "audio %d/%d RTP/AVP %n", &x, &numberofports, &len) == 2) &&  len>=0) ||
+                   ((sscanf(m, "audio %d RTP/AVP %n", &x, &len) == 1) && len>=0)) {
+                       if (debug) ast_verbose("found audio RTP/AVP line, len=%i, x=%d, m='%s', numberofports=%d\n", len, x, m, numberofports);
                        audio = TRUE;
                        numberofmediastreams++;
                        /* Found audio stream in this media definition */

